#include <stdio.h>
#include <wiringPi.h>
#include "io.h"

// ピン配置
//static const int pin_sw_f  = 25;
//static const int pin_sw_l  = 21;
//static const int pin_sw_r  = 27;

// MG4
static const int pin_sw_1  = 25;
static const int pin_sw_2  = 19;
static const int pin_sw_3  = 8;
static const int pin_sw_4  = 23;
static const int pin_sw_5  = 11;
static const int pin_sw_6  = 22;
static const int pin_sw_7  = 16;
static const int pin_sw_8  = 26;

int io_open(){
	// GPIOデバイスのオープン
	if(wiringPiSetupGpio() != 0){
		printf("failed to open GPIO\n");
		return -1;
	}else{
		// ピン設定
		pinMode(pin_sw_1, INPUT);
		pinMode(pin_sw_2, INPUT);
		pinMode(pin_sw_3, INPUT);
		pinMode(pin_sw_4, INPUT);
		pinMode(pin_sw_5, INPUT);
		pinMode(pin_sw_6, INPUT);
		pinMode(pin_sw_7, INPUT);
		pinMode(pin_sw_8, INPUT);
		pullUpDnControl(pin_sw_1, PUD_UP);
		pullUpDnControl(pin_sw_2, PUD_UP);
		pullUpDnControl(pin_sw_3, PUD_UP);
		pullUpDnControl(pin_sw_4, PUD_UP);
		pullUpDnControl(pin_sw_5, PUD_UP);
		pullUpDnControl(pin_sw_6, PUD_UP);
		pullUpDnControl(pin_sw_7, PUD_UP);
		pullUpDnControl(pin_sw_8, PUD_UP);
		
		printf("GPIO opened\n");
		return 0;
	}
}

void io_get_sw(int *sw_1, int *sw_2, int *sw_3, int *sw_4, int *sw_5, int *sw_6, int *sw_7, int *sw_8){

	*sw_1 = digitalRead(pin_sw_1);
	*sw_2 = digitalRead(pin_sw_2);
	*sw_3 = digitalRead(pin_sw_3);
	*sw_4 = digitalRead(pin_sw_4);
	*sw_5 = digitalRead(pin_sw_5);
	*sw_6 = digitalRead(pin_sw_6);
	*sw_7 = digitalRead(pin_sw_7);
	*sw_8 = digitalRead(pin_sw_8);

}

/*int io_sw_detection(int *sw_1, int *sw_2, int *sw_3, int *sw_4, int *sw_5, int *sw_6, int *sw_7, int *sw_8){
	
	io_get_sw(&sw_1, &sw_2, &sw_3, &sw_4, &sw_5, &sw_6, &sw_7, &sw_8);

	if(sw_1 == 0 || sw_2 == 0 || sw_3 == 0 || sw_4 == 0 ){
		return 1;
	}

	if(sw_5 == 0 || sw_6 == 0 || sw_7 == 0 || sw_8 == 0 ){
		return 2;
	}

	return 0;
}*/

