#include <stdio.h>

#include <unistd.h>
#include <time.h>
#include <pthread.h>
#include "flag.h"
#include "timer.h"

#define MIN_HOME 1	//default 45
#define MIN_RUN  1	//default 10

static void *thread_code(void*);

static pthread_t task_id;

time_t timer;
struct tm *t_st;
int tmp_min;



//volatile int state = 1;

//Xbh֘A
int timer_srd_create() {
	int policy;
	struct sched_param param;
	// Xbh̐
	if (pthread_create(&task_id, NULL, thread_code, NULL) != 0) {
		printf("failed to create timer thread\n");
		return -1;
	}
	// Xbhp[^̊mF
	pthread_getschedparam(task_id, &policy, &param);
	printf("timer thread created (plicy = %s, priority = %d)\n",
		((policy == SCHED_FIFO) ? "SCHED_FIFO" : (policy == SCHED_RR) ? "SCHED_RR" : (policy == SCHED_OTHER) ? "SCHED_OTHER" : "???"),
		param.sched_priority);
	return 0;
}

//ԂŏԂω
void timer_std() {

	const int cycle = 10 ;	// s[ms]
	time(&timer);	//timerɌݎ̏
	t_st = localtime(&timer);	//timeret_stɑ
	tmp_min = (t_st->tm_min) + MIN_RUN;	//tmp_minɎ̖ڕW()
	if (tmp_min >= 60) {
		tmp_min -= 60;
	}
	//printf("Next is %d:00\n",tmp_min);
		
	while(1){
		time(&timer);	//timerɌݎ̏
		t_st = localtime(&timer);	//timeret_stɑ
		printf("\r[time is %d:%d, state = %d]  ", t_st->tm_min, t_st->tm_sec, state);
		
		switch (state) {
			//~->s
			case 0:
				if (t_st->tm_min == tmp_min) {

					state = 1;	//change state

					//printf("\nɕύX\n");
					tmp_min = (t_st->tm_min) + MIN_RUN;	//tmp_minɎ̖ڕW()
					if (tmp_min >= 60) {
						tmp_min -= 60;
					}
					//printf("Next is %d:00\n",tmp_min);
				}
				break;
			//s->~
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
				if (t_st->tm_min == tmp_min) {

					state = 0;	//change state

					//printf("\nҋ@ɕύX\n");
					tmp_min = (t_st->tm_min) + MIN_HOME;
					if (tmp_min >= 60) {
						tmp_min -= 60;
					}
					printf("Next is %d:00\n",tmp_min);
				}
				break;
			default:
				break;
		}
	usleep(cycle * 1000);
	}
	printf("timer_std end");
}

void *thread_code(void *t){

	timer_std(state);
	return 0;
}

void timer_cancel(){
	pthread_cancel(task_id);
	printf("timer thread canceled\n");
}


